/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


/**
 *
 * @author wwerapun
 */
public class Dijkstra {

    private Graph graph;
    //priority queue stores all of the nodes, reachable from the start node
    //The queue is sorted by the node.distance
    private GraphPriorityQueue priorityQ = new GraphPriorityQueue();
    
    //private Hashtable<Node, Integer> distance = new Hashtable<Node, Integer>();

    //1. needs to get the list of all nodes in the graph
    //2. need to initialize distance vector to infinity
    //3. Need Edge Cost function
    public Dijkstra(Graph g) {
        this.graph = g;
        this.graph.rootNode.distance = 0;
        this.priorityQ.add(this.graph.nodes);
    }

    /**
     * Actual algorithm
     */
    public void go() {

        while (this.priorityQ.hasMore()) {
            Node n = this.priorityQ.remove();
            n.visited = true;
            Node child = null;
            //System.out.println("Node =" + n.label);
            while ((child = graph.getUnvisitedChildNode(n)) != null) {
                child.visited = true;
                //graph.printNode(child);
                Integer newPossiblePathCost = n.distance + 1;                
                if (newPossiblePathCost < child.distance) {
                    child.distance = newPossiblePathCost;
                    this.priorityQ.updateGraphNodeDistance(child);                    
                }
                 // this.priorityQ.PrintContents();
                // System.out.println("Cost =" + newPossiblePathCost);
            }
        }
 
       
 
    }


    public void PrintStatusOfPriorityQ() {
        this.priorityQ.PrintContents();
    }
}
